unit client1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ComCtrls, ToolWin, ExtCtrls, DBClient, CorbaCon, Db, DBCtrls,
  Grids, DBGrids, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    DBGrid2: TDBGrid;
    CorbaConnection1: TCorbaConnection;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    ClientDataSet2: TClientDataSet;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    ClientDataSet1CustNo: TFloatField;
    ClientDataSet1Company: TStringField;
    ClientDataSet1Addr1: TStringField;
    ClientDataSet1Addr2: TStringField;
    ClientDataSet1City: TStringField;
    ClientDataSet1State: TStringField;
    ClientDataSet1Zip: TStringField;
    ClientDataSet1Country: TStringField;
    ClientDataSet1Phone: TStringField;
    ClientDataSet1FAX: TStringField;
    ClientDataSet1TaxRate: TFloatField;
    ClientDataSet1Contact: TStringField;
    ClientDataSet1LastInvoiceDate: TDateTimeField;
    ClientDataSet1Table2: TDataSetField;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    DBNavigator1: TDBNavigator;
    ToolButton7: TToolButton;
    Edit1: TEdit;
    Button1: TButton;
    ClientDataSet2OrderNo: TFloatField;
    ClientDataSet2CustNo: TFloatField;
    ClientDataSet2SaleDate: TDateTimeField;
    ClientDataSet2ShipDate: TDateTimeField;
    ClientDataSet2EmpNo: TIntegerField;
    ClientDataSet2ShipToContact: TStringField;
    ClientDataSet2ShipToAddr1: TStringField;
    ClientDataSet2ShipToAddr2: TStringField;
    ClientDataSet2ShipToCity: TStringField;
    ClientDataSet2ShipToState: TStringField;
    ClientDataSet2ShipToZip: TStringField;
    ClientDataSet2ShipToCountry: TStringField;
    ClientDataSet2ShipToPhone: TStringField;
    ClientDataSet2ShipVIA: TStringField;
    ClientDataSet2PO: TStringField;
    ClientDataSet2Terms: TStringField;
    ClientDataSet2PaymentMethod: TStringField;
    ClientDataSet2ItemsTotal: TCurrencyField;
    ClientDataSet2TaxRate: TFloatField;
    ClientDataSet2Freight: TCurrencyField;
    ClientDataSet2AmountPaid: TCurrencyField;
    Button2: TButton;
    ClientDataSet1total: TFloatField;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ToolButton8: TToolButton;
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ClientDataSet1CalcFields(DataSet: TDataSet);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
 try
   corbaconnection1.connected:=true;
   clientdataset1.active:=true;
   clientdataset2.active:=true;
 except
   showmessage('error al conectar con el servidor');
 end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  ClientDataSet1.ApplyUpdates(-1);

end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  ClientDataSet1.filter:='substring(addr1,1,2)='+'''' + 'PO' + '''';
  ClientDataSet1.filtered:=true;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
    Toolbutton2.enabled:=clientdataset1.changecount > 0;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  ClientDataSet1.filter:='Addr1 is NULL';
  ClientDataSet1.filtered:=true;
end;

procedure TForm1.ToolButton5Click(Sender: TObject);
begin
  ClientDataSet1.filtered:=false;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
   ClientDataSet1.addindex('indiciudad','city',[ixCaseInsensitive],'','',0);
   ClientDataSet1.indexname:='indiciudad';
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
  ClientDataSet1.indexname:='';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  edit1.text:=inttostr(ClientDataSet2.aggregates[0].value);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ClientDataSet1.IndexFieldNames:='total';
end;

procedure TForm1.ClientDataSet1CalcFields(DataSet: TDataSet);
begin
   ClientDataSet1Total.value:=ClientDataSet1TaxRate.value +2;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ClientDataSet1.UndoLastChange(True);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   ClientDataSet1.CancelUpdates;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ClientDataSet1.active:=false;
  //vemos de 10 en 10.
  ClientDataSet1.PacketRecords:=10;
  ClientDataSet1.FetchOnDemand:=false;
  Clientdataset1.active:=true;
  //activamos el 2 para ver los registros detalle
  clientdataset2.active:=true;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
   ClientDataSet1.GetNextPacket;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   ClientDataSet1.packetrecords:=-1;
   ClientDataSet1.FetchOnDemand:=true;
end;

procedure TForm1.ToolButton8Click(Sender: TObject);
begin
  clientdataset1.refresh;
end;

end.
