unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, Grids, DBGrids, Menus,StdCtrls,db;


type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Ver1: TMenuItem;
    Delta1: TMenuItem;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    Modificaciones1: TMenuItem;
    Commit1: TMenuItem;
    Rollback1: TMenuItem;
    procedure Commit1Click(Sender: TObject);
    procedure Rollback1Click(Sender: TObject);
    procedure Delta1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.DFM}

procedure TForm1.Commit1Click(Sender: TObject);
begin
  with Datamodule2 do
  begin
    if Clientdataset1.State in [dsEdit, dsInsert] then
      Clientdataset1.Post;
    if Clientdataset1.ChangeCount > 0 then
    begin
      Clientdataset1.ApplyUpdates(-1);
      Clientdataset1.Refresh;
      clientdataset1.LogChanges:=true;
      Clientdataset1.MergeChangeLog;
    end;
    if ClientDataset2.State in [dsEdit, dsInsert] then
      ClientDataset2.Post;
    if Clientdataset2.ChangeCount > 0 then
    begin
      Clientdataset2.ApplyUpdates(-1);
      ClientDataset2.Refresh;
      clientdataset2.LogChanges:=true;
      clientdataset2.mergechangelog;
    end;

  end;

end;

procedure TForm1.Rollback1Click(Sender: TObject);
begin
  datamodule2.ClientDataset1.CancelUpdates;
  datamodule2.Clientdataset2.CancelUpdates;
end;

procedure TForm1.Delta1Click(Sender: TObject);
begin
  //con la propiedad delta podemos ver los datos modificados
  // con su valor antiguo y nuevo
  Application.CreateForm(TForm3, Form3);
  try
    with Datamodule2 do
    begin
      if Clientdataset1.ChangeCount > 0 then
      begin
        Clientdataset3.Close;
        Clientdataset3.Data := Clientdataset1.Delta;
        Clientdataset3.Open;
      end;
      if Clientdataset2.ChangeCount >0 then
      begin
        Clientdataset4.Close;
        Clientdataset4.Data := Clientdataset2.Delta;
        Clientdataset4.Open;
      end;
    end;
    Form3.ShowModal;
  finally
    Form3.Free;
  end;
end;

end.

end.
